CSL 5.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
PME Class Reference

`#include <PME.h>`

List of all members.

## Public Member Functions
bool | add_pme_source (PMESource &s)
void | remove_all_sources ()
void | manage_sources ()
void | set_remote_addr_and_port (string addr, unsigned short port)
void | start_management_thread ()
void | stop_management_thread ()
| PME (string remote_net_addr, unsigned short remote_port)
| PME ()
| ~PME ()

## Static Public Member Functions
static void * | management_func (void *data)

## Protected Member Functions
void | update_grabbed_position (CPoint &p)
bool | check_for_grabbed_source (CPoint &p)

## Protected Attributes
csl::ThreadPthread | management_thread
Controller | controller
PMESource ** | pme_source_list
PMESource * | grabbed_source
unsigned short | num_sources
bool | keep_processing_sources

## Detailed Description

Definition at line 136 of file PME.h.

## Constructor & Destructor Documentation

PME::PME | ( | string | remote_net_addr,
|  | unsigned short | remote_port
| ) |  |

Definition at line 300 of file PME.cpp.

References MAX_NUM_VBAP_SOURCES, and pme_source_list.

PME::PME | ( |  | ) |

Definition at line 306 of file PME.cpp.

References MAX_NUM_VBAP_SOURCES, and pme_source_list.

PME::~PME | ( |  | ) |

Definition at line 312 of file PME.cpp.

References pme_source_list.

## Member Function Documentation

void PME::update_grabbed_position | ( | CPoint & | p | ) |
| protected

Definition at line 314 of file PME.cpp.

References grabbed_source, and PMESource::set_position().

Referenced by manage_sources().

bool PME::check_for_grabbed_source | ( | CPoint & | p | ) |
| protected

Definition at line 331 of file PME.cpp.

References csl::CPoint::distance2(), PMESource::get_position(), grabbed_source, kGrabbed, MIN_GRAB_DISTANCE_SQ, num_sources, pme_source_list, and PMESource::set_current_move_type().

Referenced by manage_sources().

bool PME::add_pme_source | ( | PMESource & | s | ) |

Definition at line 320 of file PME.cpp.

References MAX_NUM_VBAP_SOURCES, num_sources, and pme_source_list.

void PME::remove_all_sources | ( |  | ) |
| inline

Definition at line 151 of file PME.h.

void PME::manage_sources | ( |  | ) |

Definition at line 344 of file PME.cpp.

References check_for_grabbed_source(), controller, PMESource::get_current_move_type(), Controller::get_data(), PMESource::get_next_move_type(), Controller::get_remote_data(), GET_TIME, grabbed_source, kBounce, kClosed, kDraw, keep_processing_sources, kGrabbed, kOpen, kOrbit, kPoint, kStopped, num_sources, pme_source_list, PMESource::push_trace(), PMESource::reset_trace(), PMESource::set_bounce_velocity(), PMESource::set_current_move_type(), PMESource::set_orbit(), csl::sleepUsec(), SUB_TIMES, update_grabbed_position(), PMESource::update_move_type(), and PMESource::update_position().

Referenced by management_func().

void PME::set_remote_addr_and_port | ( | string | addr,
|  | unsigned short | port
| ) |  |
| inline

Definition at line 154 of file PME.h.

void * PME::management_func | ( | void * | data | ) |
| static

Definition at line 409 of file PME.cpp.

References manage_sources().

Referenced by start_management_thread().

void PME::start_management_thread | ( |  | ) |

Definition at line 415 of file PME.cpp.

References csl::ThreadPthread::createThread(), management_func(), and management_thread.

void PME::stop_management_thread | ( |  | ) |

Definition at line 419 of file PME.cpp.

References keep_processing_sources.

## Member Data Documentation

csl::ThreadPthread PME::management_thread
| protected

Definition at line 139 of file PME.h.

Referenced by start_management_thread().

Controller PME::controller
| protected

Definition at line 140 of file PME.h.

Referenced by manage_sources().

PMESource** PME::pme_source_list
| protected

Definition at line 141 of file PME.h.

Referenced by add_pme_source(), check_for_grabbed_source(), manage_sources(), PME(), and ~PME().

PMESource* PME::grabbed_source
| protected

Definition at line 142 of file PME.h.

Referenced by check_for_grabbed_source(), manage_sources(), and update_grabbed_position().

unsigned short PME::num_sources
| protected

Definition at line 143 of file PME.h.

Referenced by add_pme_source(), check_for_grabbed_source(), and manage_sources().

bool PME::keep_processing_sources
| protected

Definition at line 147 of file PME.h.

Referenced by manage_sources(), and stop_management_thread().

The documentation for this class was generated from the following files:

- CSL/Spatializers/VBAP/PME.h
- CSL/Spatializers/VBAP/PME.cpp